using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace WindowsApplication6
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtDim;
		private System.Windows.Forms.Button btnGenerate;
		private System.Windows.Forms.Label lblDim;
		private System.Windows.Forms.DataGrid dgMatrix;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
					//t.Suspend();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtDim = new System.Windows.Forms.TextBox();
			this.btnGenerate = new System.Windows.Forms.Button();
			this.lblDim = new System.Windows.Forms.Label();
			this.dgMatrix = new System.Windows.Forms.DataGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			((System.ComponentModel.ISupportInitialize)(this.dgMatrix)).BeginInit();
			this.SuspendLayout();
			// 
			// txtDim
			// 
			this.txtDim.Location = new System.Drawing.Point(112, 16);
			this.txtDim.Name = "txtDim";
			this.txtDim.Size = new System.Drawing.Size(40, 20);
			this.txtDim.TabIndex = 0;
			this.txtDim.Text = "";
			// 
			// btnGenerate
			// 
			this.btnGenerate.Location = new System.Drawing.Point(160, 16);
			this.btnGenerate.Name = "btnGenerate";
			this.btnGenerate.Size = new System.Drawing.Size(64, 24);
			this.btnGenerate.TabIndex = 1;
			this.btnGenerate.Text = "Generate";
			this.btnGenerate.Click += new System.EventHandler(this.btnGenerate_Click);
			// 
			// lblDim
			// 
			this.lblDim.Location = new System.Drawing.Point(8, 16);
			this.lblDim.Name = "lblDim";
			this.lblDim.Size = new System.Drawing.Size(96, 16);
			this.lblDim.TabIndex = 2;
			this.lblDim.Text = "Matrix Dimension";
			// 
			// dgMatrix
			// 
			this.dgMatrix.DataMember = "";
			this.dgMatrix.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgMatrix.Location = new System.Drawing.Point(8, 48);
			this.dgMatrix.Name = "dgMatrix";
			this.dgMatrix.Size = new System.Drawing.Size(296, 208);
			this.dgMatrix.TabIndex = 3;
			this.dgMatrix.Visible = false;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(232, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "Write XML";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(312, 262);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.dgMatrix);
			this.Controls.Add(this.lblDim);
			this.Controls.Add(this.btnGenerate);
			this.Controls.Add(this.txtDim);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dgMatrix)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private DataTable dtMatrix;
		//private Thread t;

		private void btnGenerate_Click(object sender, System.EventArgs e)
		{
//			t = new Thread(new ThreadStart(threadProc));
//			t.Start();

			if(0==txtDim.Text.Length)
			{
				MessageBox.Show("Please enter an odd numner for dimension.");
				return;
			}
			int iDim=Convert.ToInt32(txtDim.Text);
			// Technique is only applied to odd number dimensions
			if(iDim % 2 != 1) 
			{
				MessageBox.Show("Dimenbsion must be odd.");
				return;
			}

			dtMatrix=new DataTable("MagicMatrix");
			// DataTable is constructed using the zero referanced column index
			for(int i=0; i<iDim; i++)
			{
				DataColumn dcMagicCol=new DataColumn();
				dcMagicCol.DataType=System.Type.GetType("System.String");
				dcMagicCol.ColumnName="column"+i.ToString();
				dtMatrix.Columns.Add(dcMagicCol);
			}

			int [,] iMatrix=ConstructMagicMatrix(iDim);
			for(int i=0; i<iDim; i++)
			{
				DataRow drMagicCol=dtMatrix.NewRow();
				for(int j=0; j<iDim; j++)
				{
					drMagicCol[j]=iMatrix[i,j].ToString();
				}
				dtMatrix.Rows.Add(drMagicCol);
			}
			dgMatrix.DataSource=dtMatrix;
			dgMatrix.Visible=true;
		}

		int [,] ConstructMagicMatrix(int iDim)
		{
			int i,j;
			int [,] magicMatrix=new int[iDim,iDim];
			bool [,] isFilled=new bool[iDim,iDim];

			for(i=0;i<iDim;i++)
			{
				for(j=0; j<iDim; j++)
				{
					isFilled[i,j]=false;
				}
			}
			int counter=1;
			j=iDim/2;
			for(i=0; ;i--, j++)
			{
				if(i<0) i=i+iDim;
				j=j%iDim;
				fillCell (ref i,ref j,magicMatrix, isFilled, counter++);
				isFilled [i,j]=true;
				if(isAllFilled(isFilled))
				{
					return magicMatrix;
				}
			}
		}
		void fillCell(ref int i, ref int j, int[,] magicMatrix, bool [,] isFilled,
						  int iVal)
		{
			if (isFilled[i,j])
			{
				// restore the original position
				i=i+2; j--;
				int iDim=Convert.ToInt32(Math.Sqrt(isFilled.Length));
				i=i%iDim;
				if(j<0) j+=iDim;
				if(i<0) i=i+iDim;

				j=j%iDim;
				fillCell(ref i, ref j, magicMatrix, isFilled,iVal);
			} 
			else
			{
				magicMatrix[i,j]=iVal;
				//MessageBox.Show("i,j = "+i.ToString()+","+j.ToString()+".");
			}
		}

		bool isAllFilled(bool [,] isFilled)
		{
			bool bAllFilled=true;
			int iDim=Convert.ToInt32(Math.Sqrt(isFilled.Length));
			for(int i=0; i<iDim; i++)
			{
				for(int j=0; j<iDim; j++)
				{
					if(!isFilled[i,j]) bAllFilled=false;
				}
			}
			return bAllFilled;
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			dtMatrix=null;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			string strMessage="";
			if(dtMatrix!= null)
			{
				saveFileDialog1.ShowDialog();
				DataSet dsMatrix=new DataSet("magicMatrix");
				dsMatrix.Tables.Add(dtMatrix);
				dsMatrix.WriteXml(saveFileDialog1.FileName);
				dsMatrix.Dispose();
				strMessage="Saved successfully.";
			}
			else
			{
				strMessage="First you must generate the datatable in order to write the XML file.";
			}
			MessageBox.Show(strMessage);
		}

		public static void threadProc() 
		{
			while(true)
			{
				Application.DoEvents();
				// Yield the rest of the time slice.
				//Thread.Sleep(0);
			}
		}
	}
}
